﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region
	
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim oSQL As SQL
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private DBName As String
	
	Private spSeason As Spinner
	Private spEpisodes As Spinner
		
	Private lblQuestion As Label
	Private rbtAnswer1 As RadioButton
	Private rbtAnswer2 As RadioButton
	Private rbtAnswer3 As RadioButton
	
	'Main Code for List/Answers Trivia
	Private ChosenSeason, ChosenEpisode As String
	Private QuestionList As List
	Private CorrectAnswer As String
	Private QNumber As Int
	
	Private Dialog As B4XDialog
	Private XUI As XUI
	Private ColorTemplate As B4XColorTemplate

	Private pnlTrivia As Panel
	Private btnStartQuiz As Button
	
End Sub


'****************    The Database structure hase been changed !
'ExecNonQuery("CREATE TABLE Season1 (ID INTEGER PRIMARY KEY, Episode TEXT, Question TEXT, ChoiceOne TEXT, ChoiceTwo TEXT, ChoiceThree TEXT, Answer TEXT)")


'This project works on the following DB assumptions / structure .
	
'1.   A separate DB file for Each TV Series	 (one word , lowercase, ie: fullerhouse) ....  with planning and change you can have a single DB
'2.   Each DB has Tables defined for Seasons  ie: Season1, Season2 .....  the table names are extracted and used to populate Season Spinner
'3.   Each Table has 5 fields , ID,  Episode, Question, ChoiceOne, ChoiceTwo, ChoiceThree, Answer  (all TEXT)   note ID's probably not needed ... just habit
'4.   At present , each Table  holds 12 rows for EACH EPISODE x number of episodes (** you might need to query DB Table to determine Episode Count to control Question Counter (QNumber)

'5   Personally . I believe storing the Answer as a TEXT is the most simplest way to test for correct answer.  ie: If RadioButton.Text = CorrectAnswer the all good.   



Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("Questions")
	
	'Activity.SetBackgroundImage(LoadBitmap(File.DirAssets, "jerichobackground.png"))
	
	'@@@   Extract db name from choosen TV Series(Main Activity)  ie: Fuller House = fullerhouse.db    SEE ABOVE FOR DATABASE DETAILS !
	Dim Series As String = Main.ChosenSeries.Replace(" ","").ToLowerCase 'removes spaces, alters to lowercase the choosen TV series from Main.Combobox
	DBName = $"${Series}.db"$
	
	'Initialize DB
	If File.Exists(File.DirInternal, DBName) = False Then
		File.Copy(File.DirAssets, DBName, File.DirInternal, DBName)
	End If
	oSQL.Initialize(File.DirInternal, DBName, False)
	
	'populate the TV Season spinner by getting all TABLE names from DB
	Wait For (PopulateSeasonSpinner) Complete (Result As Object)

	'populate spinner
	spEpisodes.AddAll(Array As String("Episodes", "1","2","3","4","5","6","7","8","9","10"))
	'spEpisodes.DropdownTextColor = Colors.White
	'spEpisodes.DropdownBackgroundColor = Colors.Gray
	
	'Set initial / part title
	Activity.Title = $"${Main.ChosenSeries} Trivia "$ 
	
End Sub

Sub PopulateSeasonSpinner As ResumableSub
	
	'extract db table names (Series)
	Dim res As ResultSet  = oSQL.ExecQuery("SELECT name FROM sqlite_master WHERE type='table'")
	
	spSeason.Add("Season")
	Do While res.NextRow
		spSeason.Add(res.GetString("name"))
		Log (res.GetString("name"))
	Loop
	
	Return Null
	
End Sub


Sub spSeason_ItemClick (Position As Int, Value As Object)
	
	If Value = "Season" Then Return 		'Message ... hey pick a Season
	
	pnlTrivia.Visible = False	'@@@@ Hide Trivia Panel & show Button
	btnStartQuiz.Visible = True
	
	ChosenSeason = Value
	
	If ChosenEpisode <> "" Then
		Wait For (PopulateQuestionLists) Complete (Result As Object)
	End If
	
	Activity.Title = $"${Main.ChosenSeries}   ${ChosenSeason} Trivia "$
End Sub


Sub spEpisodes_ItemClick (Position As Int, Value As Object)
	If Value = "Episodes" Then Return 		'Message ... hey pick a episode number
	
	pnlTrivia.Visible = False	'@@@@ Hide Trivia Panel & show Button
	btnStartQuiz.Visible = True
	
	ChosenEpisode = Value
	
	If ChosenSeason <> "" Then
		Wait For (PopulateQuestionLists) Complete (Result As Object)
	End If
	
	Activity.Title = $"${Main.ChosenSeries}   ${ChosenSeason} - Episode ${ChosenEpisode}  Trivia "$
	
End Sub

Sub PopulateQuestionLists As ResumableSub
	
	QuestionList.Initialize
	Dim res As ResultSet  = oSQL.ExecQuery($"SELECT * FROM ${ChosenSeason} WHERE Episode = ${ChosenEpisode}"$)'ChosenSeason = Table Name
	Do While res.NextRow
		Log(res.GetString("Question"))
		Log(res.GetString("ChoiceOne"))
		Log(res.GetString("ChoiceTwo"))
		Log(res.GetString("ChoiceThree"))
		Log(res.GetString("Answer"))
		Log(" ")
		
		Dim Data(5) As String
		Data(0) = res.GetString("Question")
		Data(1) = res.GetString("ChoiceOne")
		Data(2) = res.GetString("ChoiceTwo")
		Data(3) = res.GetString("ChoiceThree")
		Data(4) = res.GetString("Answer")		
		
		QuestionList.Add(Data)		
	Loop
	
	Return Null
	
End Sub

Sub btnStartQuiz_Click
	
	'reset variable, show trivia panel & hide start button
	QNumber = 0
	pnlTrivia.SetVisibleAnimated(600, True)	'@@@@Show Trivia Panel
	btnStartQuiz.Visible = False
	
	StartTriviaQuestions  'load next question set ... see below
	
End Sub

Sub StartTriviaQuestions
	
	'populate string array with next question set
	Dim QuestionData(5) As String = QuestionList.Get(QNumber)
	
	For i = 0 To 4		'LOG
		Log(QuestionData(i))
	Next
	
	'populate views from array
	lblQuestion.Text = QuestionData(0)		'Question is 1st Value in QuestionData(0) array
	
	'......................      Randomize 3 Ints (1 - 3) and use result to randomly load Answers from QuestionData(1-3) array
	Dim IntArray() As Int = Array As Int(1, 2, 3)
	ShuffleArray(IntArray)
	
	Log($"Shuffled Array Order =  ${IntArray(0)}  ,  ${IntArray(1)}   ,  ${IntArray(2)} "$ )
	
	rbtAnswer1.Text = QuestionData(IntArray(0))
	rbtAnswer2.Text = QuestionData(IntArray(1))
	rbtAnswer3.Text = QuestionData(IntArray(2))
	
	'.....................
	
	CorrectAnswer = QuestionData(4) 'Correct Answer  is 5th Value in QuestionData(4) array
	
	
	'@@@@@@@@@@    Your Choice .  Just needed some visual way of announcing new questions set  ...
	pnlTrivia.Visible = False
	pnlTrivia.Color = Colors.RGB(Rnd( 200, 256), Rnd( 200, 256), Rnd( 200, 256))   '(200, 256) = Light Color   (0- 200) Darker
	Sleep(200)
	pnlTrivia.SetVisibleAnimated(600, True)
	
End Sub

Sub rbtAnswer_CheckedChange(Checked As Boolean)
	If Checked  Then
		Dim rbt As RadioButton = Sender
		
		If rbt.Text = CorrectAnswer Then
			MsgboxAsync("Correct answer", "Result")
			Wait For MsgBox_Result (Result As Int)
			
			'Increase My Score !
			btnNext_Click
		Else
			MsgboxAsync("Wrong answer", "Result")
			Wait For MsgBox_Result (Result As Int)
			
			'Reset ????
			rbtAnswer1.Checked = False
			rbtAnswer2.Checked = False
			rbtAnswer3.Checked = False			
		End If
	End If
End Sub

Sub btnNext_Click

	If QNumber = 12 Then
		'Result = Msgbox2("Episode One Completed", "Score", "Continue", "Finish", "", Null)
		Msgbox2Async("Do you wish to continue ?", $"Episode ${ChosenEpisode}"$, "Continue", "Score", "Finnish", Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
		
			'Pick another Season or Episode and start again ?
		
		Else if Result = DialogResponse.NEGATIVE Then
			Activity.Finish '???????
		Else
			'Show me my score ??
		End If
	End If
	
	QNumber = QNumber +1
	rbtAnswer1.Checked = False
	rbtAnswer2.Checked = False
	rbtAnswer3.Checked = False
	
	StartTriviaQuestions
	
End Sub


Sub ShuffleArray(IntArray() As Int) 'Question order randomiser
	Dim ArrayVal As Int
	Dim Random As Int
 
	For i = 0 To IntArray.Length - 1
		Random = Rnd(i, IntArray.Length)
		ArrayVal = IntArray(i)
		IntArray(i) = IntArray(Random)
		IntArray(Random) = ArrayVal
	Next
	
End Sub



Sub btncolor_Click
	Wait For (Dialog.ShowTemplate(ColorTemplate, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = XUI.DialogResponse_Positive Then
		'Base.Color = ColorTemplate.SelectedColor
	End If
End Sub
Sub btnpanelcolor_Click
	Wait For (Dialog.ShowTemplate(ColorTemplate, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = XUI.DialogResponse_Positive Then
		'Base1.Color = ColorTemplate.SelectedColor
	End If
End Sub


Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

	





